package com.winhc.repal.service.impl;

import com.winhc.repal.entity.RepalRemindHistory;
import com.winhc.repal.repository.RepalRemindHistoryMapper;
import com.winhc.repal.service.RepalRemindHistoryService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.winhc.common.model.base.VOPage;
import com.winhc.repal.model.dto.RepalRemindHistoryDTO;
import com.winhc.repal.model.cvt.RepalRemindHistoryConvert;
import com.winhc.repal.model.vo.RepalRemindHistoryVO;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @description RepalRemindHistory 接口实现类
 * @author Generator
 * @date 2022-04-08
 */
@Service
public class RepalRemindHistoryServiceImpl extends ServiceImpl<RepalRemindHistoryMapper, RepalRemindHistory> implements RepalRemindHistoryService {

    @Override
    public void add(RepalRemindHistoryDTO dto) {
        save(RepalRemindHistoryConvert.DTOToEntity(dto));
    }

    @Override
    public void update(Long id, RepalRemindHistoryDTO dto) {
        update(RepalRemindHistoryConvert.DTOToEntity(dto),new UpdateWrapper<RepalRemindHistory>().lambda().eq(RepalRemindHistory::getId,id));
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

    @Override
    public RepalRemindHistoryVO find(Long id) {
        return RepalRemindHistoryConvert.EntityToVO(getById(id));
    }

    @Override
    public List<RepalRemindHistoryVO> find(RepalRemindHistoryDTO dto) {
        return list(new QueryWrapper<>(RepalRemindHistoryConvert.DTOToEntity(dto))).stream().map(RepalRemindHistoryConvert::EntityToVO)
                 .collect(Collectors.toList());
    }

     @Override
     public VOPage<RepalRemindHistoryVO> find(RepalRemindHistoryDTO dto, Integer pageNum, Integer pageSize) {
         IPage<RepalRemindHistory> pageRepalRemindHistory = page(new Page<>(pageNum, pageSize), new QueryWrapper<>(RepalRemindHistoryConvert.DTOToEntity(dto)));
         return new VOPage<>(pageNum,pageSize,pageRepalRemindHistory.getTotal(), pageRepalRemindHistory.getRecords().stream()
                 .map(RepalRemindHistoryConvert::EntityToVO).collect(Collectors.toList()));
    }
}
